/***************************************************************************
    copyright            : (C) 2002 by Peter Kuk
    email                : kutak@stonline.sk
 ***************************************************************************/

#include "moje_sdlfunc.h"
#include "moje_i18n.h"
#include <string.h>

SDL_Surface *fontfixed;

#ifndef MOJE_BEZZVUKOV
int myLoadWav(	Mix_Chunk *&chunk, const char *nazov)
{
	chunk = Mix_LoadWAV(nazov);
	if( chunk == NULL )
	{
		fprintf(stderr, i18n("Couldn't load sound file %s: %s\n"), nazov,	SDL_GetError());
		return 1;
	}
	return 0;
}
#endif //MOJE_BEZZVUKOV

int simBlit(	SDL_Surface *image, Sint16 x, Sint16 y, SDL_Surface *screen)
{
	SDL_Rect dest;

	/* Blit onto the screen surface*/
	dest.x = x;
	dest.y = y;
	dest.w = image->w;
	dest.h = image->h;
	return SDL_BlitSurface(image, NULL, screen, &dest);
}

#ifndef MOJE_BEZIMAGE
int myLoadImage(	SDL_Surface *&image, const char *nazov, int convert)
{
	image=IMG_Load(nazov);
	if ( image == NULL )
	{
		fprintf(stderr, i18n("Couldn't load %s: %s\n"), nazov,	SDL_GetError());
		return 1;
	}
	if(convert)
	{
		SDL_SetColorKey(image, SDL_RLEACCEL, image->format->colorkey);
	}
	return 0;
}
#endif //MOJE_BEZIMAGE

int myLoadBmp(	SDL_Surface *&image, const char *nazov, int convert, const char* fromdat)
{
	Uint32 tpix;
	SDL_Surface *imagebmp = NULL;

	if(fromdat)
	{//nahravam z DAT suboru
		void *fmem;
		long velkost;
		int rfd=readFromDAT(fromdat,nazov,fmem,velkost);
		if(rfd!=0)
		{//chyba pri citani z DAT suboru
			fprintf(stderr, i18n("Error ocured by reading %s from DAT file %s.\n"), nazov,	fromdat);
			return 1;
		};
		imagebmp = SDL_LoadBMP_RW(SDL_RWFromMem(fmem,velkost), 1);
	}else
	{//nahravam zo suboru na disku
		imagebmp = SDL_LoadBMP(nazov);
	}
	if ( imagebmp == NULL )
	{
		fprintf(stderr, i18n("Couldn't load %s: %s\n"), nazov,	SDL_GetError());
		return 1;
	}

	if(convert==1)
	{
		tpix=SDL_MapRGB(imagebmp->format, 255, 0, 255);
		SDL_SetColorKey(imagebmp, SDL_SRCCOLORKEY|SDL_RLEACCEL, tpix);
		image = SDL_DisplayFormat(imagebmp);
		SDL_FreeSurface(imagebmp);
	}else
	{
		image = imagebmp;
	}
	return 0;
};

SDL_Surface *textToRasterSurface(char *text,unsigned char r,unsigned char g,unsigned char b,unsigned char a/*=SDL_ALPHA_OPAQUE*/)
{//TODO:mozno by sa mohla vypustit optimalizacia cez dva surface ved aj tak sa vysledok pouzije iba raz -> vypustenim 2. surface mozno usetrim viac
	//TODO: mozno by bolo dobre dorobit podporu viacerych riadkov s centrovanim - alebo urobyt novu funkciu, ktora by poskladala viac riadkov do jedeho Surface
	SDL_Surface *surface;
	SDL_Surface *ksurface;
	SDL_Rect dest={0,0,7,12};
	SDL_Rect scr={0,0,7,12};
	SDL_Color farba={r,g,b};
	int dlzka=strlen(text);
	SDL_Color paleta[3]={{255,0,255},{255,255,255},{0,0,0}};
		
	ksurface = SDL_CreateRGBSurface(SDL_SWSURFACE, dlzka*7, 12, 8, 0, 0, 0, 0);
	SDL_SetColors(ksurface, paleta, 0, 2);
	for (int c=0;c<dlzka;c++)
	{
		dest.x = c*7;
		scr.x=((text[c]-32)%32)*7;
		scr.y=((text[c]-32)/32)*12;
		SDL_BlitSurface(fontfixed, &scr, ksurface, &dest);
	}
	SDL_SetColors(ksurface, &farba, 1, 1);

	SDL_SetColorKey(ksurface, SDL_SRCCOLORKEY|SDL_RLEACCEL,0 );
	SDL_SetAlpha(ksurface,(a==SDL_ALPHA_OPAQUE?0:SDL_SRCALPHA) , a);
	surface = SDL_DisplayFormat(ksurface);
	SDL_FreeSurface(ksurface);
	return surface;
};


SDL_Surface *colorizuj(SDL_Surface *original,SDL_Color farba)
{
//funguje to len na indexovane subory nahrate bez konverzie?
	SDL_Surface *surface;
	SDL_Surface *ksurface;
	ksurface = SDL_ConvertSurface(original, original->format, 0);
	SDL_SetColors(ksurface, &farba, SDL_MapRGB(ksurface->format,255,255,255), 1);
	SDL_SetColorKey(ksurface, SDL_SRCCOLORKEY|SDL_RLEACCEL,SDL_MapRGB(ksurface->format, 255, 0, 255) );
	surface = SDL_DisplayFormat(ksurface);
	SDL_FreeSurface(ksurface);
	return surface;
}

